;----------------------;
;--Main-Script-Editor--;
;----------------------;

Graphics 800, 600, 16, 2
SetBuffer BackBuffer()

AppTitle "Kein Titel - Editor"
SeedRnd MilliSecs()

Global Timer = CreateTimer(60)

Include "scripts\editor\menubar by addi.bb"
Include "scripts\editor\blitzui demo by addi.bb"

;------------------------------------------------------------Erstellen der Menbar-------------------------------------------------------------;

Global MenuBar	  = CreateMenuBar()

Global File   	  = CreateMenuBarTitel("Datei", MenuBar)
Global MenNew	  = CreateTitelItem("Neu", File)
Global MenOpen	  = CreateTitelItem("ffnen", File)
Global MenSave	  = CreateTitelItem("Speichern", File)
Global MenAppExit = CreateTitelItem("Ende", File)

Global Prob  	= CreateMenuBarTitel("Bearbeiten", MenuBar)
Global MenSize	= CreateTitelItem("Gre", Prob)
Global MenTile	= CreateTitelItem("Tileset", Prob)
Global MenWorld	= CreateTitelItem("Welten", Prob)

Global MBLayer 	= CreateMenuBarTitel("Layer", MenuBar)
Global MenL1	= CreateTitelItem("Normal", MBLayer)
Global MenL2	= CreateTitelItem("Kollision", MBLayer)

Global View     = CreateMenuBarTitel("Ansicht", MenuBar)
Global MenGrid  = CreateTitelItem("Gitter", View)
Global MenMinMa = CreateTitelItem("MiniMap", View)

;------------------------------------------------------------Erstellen der Fenster-------------------------------------------------------------;

Global Window  = CreateWindow("", 265, 225, 270, 150, False)
Global Label1  = CreateLabel ("", 15, 15, Window)
Global Label2  = CreateLabel ("", 15, 60, Window)
Global Label3  = CreateLabel ("Name:", 15, 98, Window)

Global ListBox1 = CreateListBox( 15, 35, 100, 55, 3, Window)
Global ListBox2 = CreateListBox( 15, 35, 100, 55, 3, Window)
Global ListBox3 = CreateListBox( 140, 35, 100, 55, 3, Window)

Global TextBox1 = CreateTextBox(85, 35, 100, 20, Window)
Global TextBox2 = CreateTextBox(85, 80, 100, 20, Window)
Global TextBox3 = CreateTextBox(85, 95, 100, 20, Window)

Global Button1 = CreateButton("Ok", 105, 110, 60, 20, Window)
Global Button2 = CreateButton("Ok", 105, 110, 60, 20, Window)
Global Button3 = CreateButton("Ok", 105, 110, 60, 20, Window)
Global Button4 = CreateButton("Ok", 105, 110, 60, 20, Window)
Global Button5 = CreateButton("Ok", 105, 124, 60, 20, Window)
Global Button6 = CreateButton("Add", 15, 124, 60, 20, Window)
Global Button7 = CreateButton("Remove", 195, 124, 60, 20, Window)

;----------------------------------------------------------------Sonstige Vars-----------------------------------------------------------------;

;Variablen
Global Grid
Global MiniMap
Global Layer

Global ScrX
Global ScrY

Global MapMaxX = 48
Global MapMaxY = 36

Global CurrTile = 1

;Player Spawnpoint
Global PlayerX
Global PlayerY
Global PlayerD

Global FinishX
Global FinishY
Global FinishD

;Bild laden
Global TS = 1

Global Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+"\tileset.png", 32, 32, 0, 20)
MaskImage Tileset, 255, 0, 255

Global ColTile = LoadImage("gfx\tilesets\coltile.png")
MaskImage ColTile, 255, 0, 255

;Die Map dimensionieren
Dim Map(MapMaxX, MapMaxY, 1)

;Maps in ListBox1 lesen
Dir = ReadDir("worlds\maps\")
While True
	TempF$ = NextFile$(Dir)
	If TempF$="" Then
		Exit
	Else If Left(TempF$, 1)<>"." Then
		AddListBoxItem(TempF$, ListBox1)
	End If
Wend

;Tilesets in ListBox2 einladen
Dir = ReadDir("gfx\tilesets\")
While True
	TempF$ = NextFile$(Dir)	
	If TempF$="" Then
		Exit
	Else If FileType("gfx\tilesets\"+TempF$)=2 And Left(TempF$, 1)<>"." Then
		AddListBoxItem(TempF$, ListBox2)
	End If
Wend

;----------------------------------------------------------------Hauptschleife-----------------------------------------------------------------;

ClsColor 0, 0, $008CD3
While Not KeyHit(1)
	Cls
	
	TempMouseX = MouseX()
	TempMouseY = MouseY()
	
	MouseState = False
	If MouseHit(1) Then MouseState = 1:FlushMouse
	If MouseHit(2) Then MouseState = 2:FlushMouse
	
	;Scrollen
	If KeyDown(205) Then ScrX = ScrX+8
	If KeyDown(203) Then ScrX = ScrX-8
	
	If KeyDown(200) Then ScrY = ScrY-8
	If KeyDown(208) Then ScrY = ScrY+8
	
	;Tiles mit Mausrad whlen
	Select MouseZSpeed()
	Case -1
		If CurrTile>1 Then CurrTile = CurrTile-1		
	Case 1
		If CurrTile<20 Then CurrTile = CurrTile+1		
	End Select
	
	;--------------------------------------------------------------------------;

	;Map und Tilebar und Gegner-Spawnpoints zeichnen
	DrawMap()
	DrawTilebar()

	;Felder setzen und oder lschen
	If (TempMouseY-20+ScrY)/32>-1 And (TempMouseY-20+ScrY)/32<MapMaxY+1 And (TempMouseX+ScrX)/32>-1 And (TempMouseX+ScrX)/32<MapMaxX+1 And WindowAktiv()=False And TitelSelected()=False Then
		
		;Tile an Mausposition zeichnen
		If TempMouseY<567 Then 
			If Layer=0 Then 
				DrawImage Tileset, (TempMouseX+ScrX)/32*32-ScrX, (TempMouseY+ScrY-20)/32*32+20-ScrY, CurrTile-1
			Else
				DrawImage ColTile, (TempMouseX+ScrX)/32*32-ScrX, (TempMouseY+ScrY-20)/32*32+20-ScrY
			End If
		End If
		
		;Tile setze/lschen
		If TempMouseY<567 And MouseState=1 Then
			If Layer=0 Then 
				If CurrTile<>12 And CurrTile<>20 Then 
					Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32, Layer) = CurrTile 
				Else 
					If CurrTile=12 Then 
						FinishX = (TempMouseX+ScrX)/32*32
						FinishY = (TempMouseY-20+ScrY)/32*32
						FinishD = True
					End If
					If CurrTile=20 Then
						PlayerX = (TempMouseX+ScrX)/32*32
						PlayerY = (TempMouseY-20+ScrY)/32*32
						PlayerD = True
					End If
				End If
			Else
				Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32, Layer) = 1
			End If
		End If	
			
		If TempMouseY<567 And MouseState=2 Then Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32, Layer) = 0
	End If
		
	;--------------------------------------------------------------------------;
	
	;Menbar und Windows rendern
	RenderMenuBar()
	RenderWindow()
	
	;Checken ob ein Menbarunterpunkt geklickt wurde
	Select CheckEvent()
	Case MenNew
		ClearMap()
	Case MenOpen
		OpenMenu("Load")
	Case MenSave
		OpenMenu("Save")
	Case MenAppExit
		End
	Case MenSize
		OpenMenu("Size")
	Case MenTile
		OpenMenu("Tileset")
	Case MenWorld
		OpenMenu("World")
	Case MenL1
		Layer = 0
	Case MenL2
		Layer = 1
	Case MenGrid
		Grid = True-Grid
	Case MenMinMa
		MiniMap = True-MiniMap
	End Select
	
	;Buttonevents checken	
	Select GetEvents("BUTTON")
	Case Button1
		;Map laden und Fenster schlieen
		LoadMap(GetSelectedListBoxItem(ListBox1))
		EnDisableGadjet(Window, False)
	Case Button2
		;Map speichern und Fenster schlieen
		SaveMap(GetTextBoxText(TextBox1)+".mpf")		
		
		If IsStringItemOfListBox(GetTextBoxText(TextBox1)+".mpf", ListBox1)=False Then AddListBoxItem(GetTextBoxText(TextBox1)+".mpf", ListBox1)
		
		SetTextBoxText(TextBox1, GetSelectedListBoxItem(ListBox1))
		
		EnDisableGadjet(Window, False)
	Case Button3
		;Die Map-Gre aus den Textboxen lesen
		MapMaxX = Int(GetTextBoxText(TextBox1))-1
		MapMaxY = Int(GetTextBoxText(TextBox2))-1
		
		;Map dimensionieren und Fenster schlieen
		ClearMap()
		EnDisableGadjet(Window, False)
	Case Button4
		;Tileset laden
		TS = Mid(GetSelectedListBoxItem(ListBox2), 8)
		
		If Tileset Then FreeImage Tileset
		Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+"\tileset.png", 32, 32, 0, 20)
		MaskImage Tileset, 255, 0, 255
		
		EnDisableGadjet(Window, False)
	Case Button5
		;Welt speichern, dazu alle Litboxeintrge in LB3 in die Datei schreiben
		Childs = GetListBoxItemNumber(ListBox3)
		
		FileOut = WriteFile("worlds\"+GetTextBoxText(TextBox3)+".wdf")
		WriteInt FileOut, Childs-1
		For I=0 To Childs-1
			WriteString FileOut, GetListBoxItemByIndex$(I, ListBox3)
		Next
		CloseFile FileOut
		
		EnDisableGadjet(Window, False)
	Case Button6
		AddListBoxItem(GetSelectedListBoxItem(ListBox1), ListBox3)
	Case Button7
		DeleteListBoxItem(GetSelectedListBoxItem(ListBox3), ListBox3)
	End Select
	
	WaitTimer Timer
	Flip(0)
Wend

FreeGui()
EndGraphics:End

;------------------------------------------------------------------Funktionen------------------------------------------------------------------;

Function DrawMap()
	;Normale Map zeichnen
	Color 0,0,$FFFFFF
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			If Map(X, Y, 0)>0 Then DrawImage Tileset, X*32-ScrX, Y*32+20-ScrY, Map(X, Y, 0)-1						
			If Map(X, Y, 1)>0 And Layer=1 Then DrawImage ColTile, X*32-ScrX, Y*32+20-ScrY
			
			If FinishD=True Then DrawImage Tileset, FinishX-ScrX, FinishY-ScrY+20, 11
			If PlayerD=True Then DrawImage Tileset, PlayerX-ScrX, PlayerY-ScrY+20, 19
			
			If Grid=True And Map(X, Y, 0)=0 And Map(X, Y, 1)=0 Then Rect X*32-ScrX, Y*32+20-ScrY, 33, 33, False
		Next
	Next
	
	;Minimap wird gezeichnet
	If MiniMap = True Then 
		Rect 800-MapMaxX*2-4, 22, MapMaxX*2+2, MapMaxY*2+2, True
		
		For Y=0 To MapMaxY
			For X=0 To MapMaxX		
				If Map(X, Y, 0)>0 And Map(X, Y, 1)=0 Then Color 0, 0, $00FF00
				If Map(X, Y, 0)=0 And Map(X, Y, 1)>0 Then Color 0, 0, $FF0000
				If Map(X, Y, 0)>0 And Map(X, Y, 1)>0 Then Color 0, 0, $0000FF
				
				If Map(X, Y, 0)>0 Or Map(X, Y, 1)>0 Then Rect 800-MapMaxX*2-4+X*2, 22+Y*2, 2, 2, True
			Next
		Next
		
		Color 0, 0, $00FF00
		Rect 800-MapMaxX*2-4 +(ScrX/32)*2, 22 +(ScrY/32)*2, 25*2, 17*2, False
		Color 0, 0, $FFFFFF
	End If
End Function

;--------------------------------------------------------------------;

;Zeichnet die Tileauswahl
Function DrawTilebar()
	Color 0, 0, $D2D2D2
	Rect 0, 567, 800, 33, True
	Color 0, 0, $A2A2A2
	Line 0, 567, 800, 600-33
	
	For X=0 To 19
		DrawImage Tileset, 32*X, 568, X
		If RectsOverlap(TempMouseX, TempMouseY, 1, 1, 32*X, 568, 32, 32) And MouseState=1 Then CurrTile = X+1
	Next	
	
	Color 0, 0, $0000FF
	Rect (CurrTile-1)*32, 600-32, 32, 32, False
End Function

;--------------------------------------------------------------------;

;Map speichern
Function SaveMap(DN$)
	FileOut = WriteFile("worlds\maps\"+DN$)
	
	WriteByte FileOut, TS
	WriteByte FileOut, MapMaxX
	WriteByte FileOut, MapMaxY
	
	WriteByte FileOut, PlayerX/32
	WriteByte FileOut, PlayerY/32
	
	WriteByte FileOut, FinishX/32
	WriteByte FileOut, FinishY/32
	
	;Map sichern
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			WriteByte FileOut, Map(X, Y, 0)
			WriteByte FileOut, Map(X, Y, 1)
		Next
	Next
	
	CloseFile FileOut
End Function

;--------------------------------;

;Map laden
Function LoadMap(DN$)
	FileIn = OpenFile("worlds\maps\"+DN$)
	
	TS = ReadByte(FileIn)
	If Tileset Then FreeImage Tileset
	
	Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+"\tileset.png", 32, 32, 0, 20)
	MaskImage Tileset, 255, 0, 255
	
	MapMaxX = ReadByte(FileIn)
	MapMaxY = ReadByte(FileIn)	
	ClearMap()
	
	PlayerX = ReadByte(FileIn)*32
	PlayerY = ReadByte(FileIn)*32
	PlayerD = True
	
	FinishX = ReadByte(FileIn)*32
	FinishY = ReadByte(FileIn)*32
	FinishD = True
	
	;Map sichern
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			Map(X, Y, 0) = ReadByte(FileIn)
			Map(X, Y, 1) = ReadByte(FileIn)			
		Next
	Next
	
	CloseFile FileIn
End Function

;--------------------------------------------------------------------;

;Map leeren
Function ClearMap()
	Dim Map(MapMaxX, MapMaxY, 1)	
End Function

;--------------------------------------------------------------------;

;Um Mens zu ffnen
Function OpenMenu(W$)
	
	EnDisableAllGadjets(False)
	EnDisableGadjet(Window, True)
	
	Select W$
	Case "Load"
		EnDisableGadjet(Label1, True)		
		EnDisableGadjet(ListBox1, True)
		EnDisableGadjet(Button1, True)
		
		SetWindowTitel(Window, "Load")
		SetLabelText(Label1, "Whlen sie eine zu ladende Map")
	Case "Save"
		EnDisableGadjet(Label1, True)		
		EnDisableGadjet(TextBox1, True)
		EnDisableGadjet(Button2, True)
		
		SetWindowTitel(Window, "Save")
		SetLabelText(Label1, "Name ihrer map?")
	Case "Size"
		EnDisableGadjet(Label1, True)
		EnDisableGadjet(Label2, True)
		EnDisableGadjet(TextBox1, True)
		EnDisableGadjet(TextBox2, True)
		EnDisableGadjet(Button3, True)
		
		SetWindowTitel(Window, "Size")
		SetLabelText(Label1, "Anzahl der Tiles in X")
		SetLabelText(Label2, "Anzahl der Tiles in Y")
	Case "Tileset"
		EnDisableGadjet(Label1, True)		
		EnDisableGadjet(ListBox2, True)
		EnDisableGadjet(Button4, True)
		
		SetWindowTitel(Window, "Load")
		SetLabelText(Label1, "Whlen sie ein Tileset")
	Case "World"
		EnDisableGadjet(Label1, True)
		EnDisableGadjet(Label3, True)
		EnDisableGadjet(ListBox1, True)	
		EnDisableGadjet(ListBox3, True)
		EnDisableGadjet(TextBox3, True)
		EnDisableGadjet(Button5, True)
		EnDisableGadjet(Button6, True)
		EnDisableGadjet(Button7, True)
		
		SetWindowTitel(Window, "Create World")
		SetLabelText(Label1, "Whlen sie eine Map")
	End Select
End Function