Type MenuBar
	Field ID
End Type

Type MenuBarTitel
	Field ID
	Field Owner
	Field Selected
	Field Cap$
End Type

Type TitelItem
	Field ID
	Field Owner
	Field Klicked
	Field Cap$
End Type

;----------------------------------------------------------------------------------------------------------------------------------------------;

Global TempMouseX
Global TempMouseY
Global MouseState

;----------------------------------------------------------------------------------------------------------------------------------------------;


;Menbar erstellen
Function CreateMenuBar()
	MB.MenuBar = New MenuBar
	
	MB\ID = Handle(MB)
	
	Return MB\ID
End Function

;Neuen Meneintrag erstellen
Function CreateMenuBarTitel(Cap$, Par)
	MBT.MenuBarTitel = New MenuBarTitel
	
	MBT\ID 	  = Handle(MBT)
	MBT\Owner = Par
	MBT\Cap$  = Cap$
	
	Return MBT\ID
End Function

;Unterpunkt erstellen
Function CreateTitelItem(Cap$, Par)
	TI.TitelItem = New TitelItem
	
	TI\ID    = Handle(TI)
	TI\Owner = Par
	TI\Cap$  = Cap$
	
	Return TI\ID
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function RenderMenuBar()
	For MB.MenuBar=Each MenuBar
		Color 0, 0, $D2D2D2
		Rect 1, 1, 798, 18, True
		Color 0, 0, $A2A2A2
		Rect 0, 0, 800, 20, False
		
		RenderMenuBarTitel(MB\ID)
	Next
End Function

;Alle Meneintrge aktuallisieren
Function RenderMenuBarTitel(Par)
	Local PosX
	
	For MBT.MenuBarTitel=Each MenuBarTitel
		If MBT\Owner=Par Then
			
			;Ausgewhlten Titel kenntlich machen
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, PosX, 0, StringWidth(MBT\Cap$)+5,20) Or MBT\Selected=True Then
				
				Color 0, 0, $C3D3ED
				Rect PosX, 0, StringWidth(MBT\Cap$)+6, 20, True
				Color 0, 0, $316AC5
				Rect PosX, 0, StringWidth(MBT\Cap$)+6, 20, False
				
				;Alle unterpunkte zeichnen
				If MBT\Selected=True Then RenderTitelItems(MBT\ID, PosX)

				;Bei Mausklick
				If MouseState=1 Then
					For MBTI.MenuBarTitel=Each MenuBarTitel
						If MBTI\ID<>MBT\ID Then MBTI\Selected = False
					Next
					
					MBT\Selected = 1-MBT\Selected
				End If
				
			End If
				
			;Text an der richtigen Stelle zeichnen
			Color 0,0,$000000
			Text 0+PosX+3, 10, MBT\Cap$, False, True
			PosX = PosX+StringWidth(MBT\Cap$)+5
			
		End If
	Next
End Function

;Diese Funktion aktuallisiert alle Unterpunkte der Meneintrge
Function RenderTitelItems(Par, X)
	Local PosY
	
	For TI.TitelItem=Each TitelItem
		If TI\Owner = Par Then
		
			Color 0, 0, $D2D2D2
			Rect X, 20+PosY, 100, 20, True
			Color 0, 0, $316AC5
			Rect X, 20+PosY, 15, 20, True
			
			;Gewhlten Unterpunkt kennzeichnen
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, X, 20+PosY, 100, 19) Then
				Color 0, 0, $C3D3ED
				Rect X+15, 20+PosY, 85, 20, True
				
				Color 0, 0, $316AC5
				Rect X+15, 20+PosY, 85, 20, False
				
				;Mausklick-Event
				If MouseState=1 Then TI\Klicked = True
			End If
			
			;Unterpunkttext schreiben
			Color 0, 0, $000000
			Text X+20, 30+PosY, TI\Cap$, False, True
			
			PosY = PosY+20
		
		End If	
	Next
End Function

;Schaut ob ein Unterpunkt geklickt wurde
Function CheckEvent()
	For TI.TitelItem=Each TitelItem
		If TI\Klicked=True Then TI\Klicked=False:Return TI\ID
	Next	
End Function

;Guckt ob ein Titel ausgewhlt ist
Function TitelSelected()
	For MBT.MenuBarTitel=Each MenuBarTitel
		If MBT\Selected Then Return True
	Next
	
	Return False
End Function