;|---------------------------------|
;|----Projekt-Button-Funktionen----|
;|---------------------------------|

Type Button
	Field X
	Field Y
	Field Width
	Field Height
	Field Pic
	Field Cap$
	Field Enabled
	Field Clicked
End Type

;Neuen Button erstellen
Function CreateButton(X,Y,W,H,Pic$,E, Cap$="")
	B.Button  = New Button
	B\X		  = X
	B\Y		  = Y
	B\Width	  = W
	B\Height  = H
	B\Pic	  = LoadAnimImage(Pic$,W,H,0,2)
	B\Cap$    = Cap$
	B\Enabled = E
	
	MaskImage B\Pic,255,0,255
	Return Handle(B)
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Buttonstate berprfen
Function GetClickedButtonID()
	For B.Button=Each Button
		If B\Clicked=True Then B\Clicked = False:Return Handle(B)
	Next
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Ein/Ausschalten der Buttons
Function EnDisableButton(ID,E)
	B.Button=Object.Button(ID)
	B\Enabled=E
End Function

Function EnDisableAllButtons(E)
	For B.Button=Each Button
		B\Enabled=E
	Next
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Diese Funktion akktualisiert alle Button
Function RenderButton()
	Color 0, 0, $000000
	
	For B.Button=Each Button
		If B\Enabled And B\X+B\Width>0 And B\X<800 And B\Y+B\Height>0 And B\Y<600 Then
			DrawImage B\Pic,B\X,B\Y,0
			
			If B\Cap$>"" Then Text B\X+B\Width/2, B\Y+B\Height/2, B\Cap$, True, True
			If RectsOverlap(TempMouseX,TempMouseY,1,1,B\X,B\Y,B\Width,B\Height) Then
				
				
				DrawImage B\Pic,B\X,B\Y,1
				
				
				If B\Cap$>"" Then Text B\X+B\Width/2, B\Y+B\Height/2, B\Cap$, True, True
				If MouseState=1 Then B\Clicked = True
			End If
		End If
	Next
	
	Color 0, 0, $FFFFFF
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Zum Zurckgeben oder ndern der Position des Button
Function GetButtonCap$(ID)
	B.Button=Object.Button(ID)
	Return B\Cap$
End Function

Function GetButtonX(ID)
	B.Button=Object.Button(ID)
	Return B\X
End Function

Function GetButtonY(ID)
	B.Button=Object.Button(ID)
	Return B\Y
End Function

Function SetButtonX(ID, X)
	B.Button=Object.Button(ID)
	B\X=X
End Function

Function SetButtonY(ID, Y)
	B.Button=Object.Button(ID)
	B\Y=Y
End Function